/// PREFS FUNCTIONS

// Returns the value of the shakensurf.enabled pref
function isEnabled() {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefBranch);

    if(prefs.getPrefType("shakensurf.enabled") == prefs.PREF_BOOL)
        return prefs.getBoolPref("shakensurf.enabled");
    else {
        prefs.setBoolPref("shakensurf.enabled", true);
        return true;
    }
}


// Returns the value of the browser.toolbars.showbutton.shakensurfMozToggle pref
function isButtonEnabled() {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefBranch);

    if(prefs.getPrefType("browser.toolbars.showbutton.shakensurfMozToggle") == prefs.PREF_BOOL)
        return prefs.getBoolPref("browser.toolbars.showbutton.shakensurfMozToggle");
    else {
        prefs.setBoolPref("browser.toolbars.showbutton.shakensurfMozToggle", true);
        return true;
    }
}


// Sets the shakensurf.enabled pref to the given boolean value
function setEnabled(enabled) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefBranch);

    return prefs.setBoolPref("shakensurf.enabled", enabled);
}

