var ShakensurfTimer = 0;
var ShakensurfFlag = -1;
var ShakensurfLastEvent = 0;
var ShakensurfOS = null;
var SnsWindowWatcher = null;
var SnsObsService = null;
var SnsTimeToDie = false;

function SnsWindowObserver() {
    SnsObsService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    Shakensurf.debug("Adding observers...");
    SnsObsService.addObserver(this,"app-startup",false);
    SnsObsService.addObserver(this,"final-ui-startup",false);
    SnsObsService.addObserver(this,"quit-application-requested",false);
    SnsObsService.addObserver(this,"quit-application-granted",false);
    SnsObsService.addObserver(this,"quit-application",false);
    SnsObsService.addObserver(this,"domwindowopened",false);
    SnsObsService.addObserver(this, "domwindowclosed", false);
    SnsObsService.addObserver(this, "xpcom-will-shutdown", false);
    SnsObsService.addObserver(this, "xpcom-shutdown", false);
    SnsObsService.addObserver(this, "browser-lastwindow-close-requested", false);
    SnsObsService.addObserver(this, "browser-lastwindow-close-granted", false);
    SnsObsService.addObserver(this, "toplevel-window-ready", false);
    SnsObsService.addObserver(this, "xul-window-destroyed", false);
    SnsObsService.addObserver(this, "dom-window-destroyed", false);

/*
    SnsObsService.addObserver(this,"quit-application-requested",false);
    SnsObsService.addObserver(this,"quit-application-granted",false);
    SnsObsService.addObserver(this,"quit-application",false);
    SnsObsService.addObserver(this,"domwindowopened",false);
    SnsObsService.addObserver(this, "domwindowclosed", false);
    SnsObsService.addObserver(this, "xpcom-will-shutdown", false);
    SnsObsService.addObserver(this, "xpcom-shutdown", false);
    SnsObsService.addObserver(this, "browser-lastwindow-close-requested", false);
    SnsObsService.addObserver(this, "browser-lastwindow-close-granted", false);
*/ 
    Shakensurf.debug("Observers added");
}

SnsWindowObserver.prototype = {
    observe: function(aSubject, aTopic, aData) {

	switch(aTopic) {
	case "quit-application-requested":
	case "quit-application-granted":
	case "quit-application":
	case "xpcom-will-shutdown":
	case "xpcom-shutdown":
	case "browser-lastwindow-close-requested":
	case "browser-lastwindow-close-granted":
	    if(!SnsTimeToDie) {
		Shakensurf.debug("STOPPING MOTION: " + aTopic);
		ins.windowAttr = "";
	        SnsTimeToDie = true;
	    }
	    break;
	default:
	    Shakensurf.debug("window event: " + aTopic + ", TimeToDie: " + SnsTimeToDie);
	    break;
	}
    }
}

var Shakensurf = {

    DEBUG: false,
    SnsTimer: null,
    prompt: null,
    inst: null,
    mainWindow: null,
    timeOut: 10,
    scrollStep: 15,
    history: null,

    debug: function(str) {
        if (!this.DEBUG) {
            return;
        }
	ins = this.getMotionInstance();
	ins.logAttr = str;
	/*
	if(!this.prompt) {
	    this.prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	}
	this.prompt.alert(null, "Shake-N-Surf", str);
	*/
    },

    getMotionInstance: function() {
	if(!this.inst) {
	    try {
		var cid = "@browser.garage.maemo.org/Motion/MotionComponent;1";
		if (!(cid in Components.classes)) {
		    this.debug("Motion Component is not installed/registered.");
		}
		else
		{
		    this.inst = Components.classes[cid].createInstance();
		    this.inst = this.inst.QueryInterface(Components.interfaces.nsIMotion);
		    //this.inst.windowAttr = "1";
		}
	    }
	    catch (e) {
		//this.debug('Failed to lookup the component: ' + e);
		return null;
	    } 
	}
	return this.inst;
    },

    getBrowserWindow: function()
    {
	
        try {
            var watcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                            .getService(Components.interfaces.nsIWindowWatcher);
            var w = watcher.activeWindow;
            return w;
        }
        catch(e) {
            //this.debug("getBrowserWindow() error: " + e);
        }
        return null;
    },

    scrollUp: function() {
	var win = this.getBrowserWindow();
	if(!win) {
	    //this.debug("scrollUp(): no current browser window available");
	    return;
	}
	try {
	    win.scrollBy(0,-this.scrollStep);
	}
	catch(e) {
	    //this.debug("scroll up failed: " + e);
	}
    },

    scrollDown: function() {
	var win = this.getBrowserWindow();
	if(!win) {
	    //this.debug("scrollDown(): no current browser window available");
	    return;
	}
	try {
	    win.scrollBy(0,this.scrollStep);
	}
	catch(e) {
	    //this.debug("scroll down failed: " + e);
	}
    },

    scrollLeft: function() {
	var win = this.getBrowserWindow();
	if(!win) {
	    return;
	}
	try {
	    win.scrollBy(-this.scrollStep, 0);
	}
	catch(e) {
	}
    },

    scrollRight: function() {
	var win = this.getBrowserWindow();
	if(!win) {
	    return;
	}
	try {
	    win.scrollBy(this.scrollStep, 0);
	}
	catch(e) {
	}
    },

    historyBack: function() {
	var win = this.getBrowserWindow();
	if(!win) {
	    return;
	}
	try {
	    win.history.back(1);
	}
	catch(e) {
	    //this.debug("historyBack() failed: " + e);
	}
    },

    historyForward: function() {
	var win = this.getBrowserWindow();
	if(!win) {
	    return;
	}
	try {
	    win.history.forward();
	}
	catch(e) {
	    //this.debug("historyForward() failed: " + e);
	}
    },

    getReading: function() {
	var ins = this.getMotionInstance();
	return ins.motionAttr;	
    },


    setTimeout: function (func, delay)
    {
	try {

            var timer =
		Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
            var callback = { 
		that: this, notify: function () {
		    func.call(this.that); 
		} 
	    };
            timer.initWithCallback(callback, delay,
			       Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	    //this.debug("setTimeout() completed, timer id: " + timer);
            return timer;
	}
	catch (e) {
	    this.debug("setTimeout() failed: " + e);
	}
    }, 

    handleTimeout: function() {

	if(SnsTimeToDie) {
	    return;
	}

	if(true) {
	    try {
		var val = parseInt(this.getReading());
		ShakensurfLastEvent = val;
	    }
	    catch (e) {
		this.debug("handleTimeout() error: " + e);
		return;
	    }
	}
	switch(ShakensurfLastEvent) {
	case 0:
	case 5:
	    break;
	case 1:
	    this.scrollUp();
	    break;
	case 2:
	    this.scrollDown();
	    break;
	case 3:
	    this.scrollLeft();
	    break;
	case 4:
	    this.scrollRight();
	    break;
	case 6:
	    this.historyBack();
	    break;
	case 7:
	    this.historyForward();
	    break;
	default:
	    //this.debug("Gesture id: " + val);
	    break;
	}
	ShakensurfTimer = this.setTimeout(this.handleTimeout, this.timeOut);	
    },

    /// INITIALIZATION CODE
    onInstall : function() {
	if(ShakensurfTimer !== 0) {
	    this.debug("onInstall(): timer is already set");
	    return;
	}
	try {
	    ShakensurfTimer = this.setTimeout(this.handleTimeout, this.timeOut);
	}
	catch(e) {
	    this.debug("error starting timer: " + e);
	}
	try {
	    SnsWindowWatcher = new SnsWindowObserver();
	}
	catch(e1) {
	    this.debug("onInstall error: " + e1);
	}
	this.debug("INSTALLED, time to die: " + SnsTimeToDie);
    }
};

window.addEventListener("load",function() {Shakensurf.onInstall();},false);
