const nsISupports = Components.interfaces.nsISupports;
const nsIObserver = Components.interfaces.nsIObserver;
const nsISupportsWeakReference = Components.interfaces.nsISupportsWeakReference;
const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
const Ci = Components.interfaces;

// You can change these if you like
const CLASS_ID = Components.ID("badeb24f-2740-49df-8937-200b1cc08f8a");
const CLASS_NAME = "Shake-N-Surf";
const CONTRACT_ID = "@mozilla.org/shakensurf;1";
const Window = Ci.nsIDOMWindow;

//
// This is your constructor.
// You can do stuff here.
function shakensurf() {
  // you can cheat and use this
  // while testing without
  // writing your own interface
    this.wrappedJSObject = this;
    var  prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    prompt.alert(null, "Shake-N-Surf", "Shake-N-Surf!");
}

// This is the implementation of your component.
shakensurf.prototype = {
  // for nsISupports
  QueryInterface: function(aIID)
  {
    // add any other interfaces you support here
    if (aIID.equals(nsIObserver))   // db242e01-e4d9-11d2-9dde-000064657374
      return this;

    if (aIID.equals(nsIWebProgressListener))  // 570F39D1-EFD0-11d3-B093-00A024FFC08C
      return this;

    if (aIID.equals(nsISupportsWeakReference))  // 9188bc85-f92e-11d2-81ef-0060083a0bcf
      return this;

    if (aIID.equals(nsISupports))   // 00000000-0000-0000-c000-000000000046
      return this;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  // nsIObserver
  observe: function(aSubject, aTopic, aData) {
    if (aTopic == "app-startup") {
      var loader = Components.classes['@mozilla.org/moz/jssubscript-loader;1']
                   .getService(Components.interfaces.mozIJSSubScriptLoader);
      loader.loadSubScript('chrome://shakensurf/content/shakensurf-prefs.js');

      var observerService = Components.classes["@mozilla.org/observer-service;1"]
                            .getService(Components.interfaces.nsIObserverService);
      observerService.addObserver(this, "domwindowopened", false);

      docLoaderSvc = Components.classes["@mozilla.org/docloaderservice;1"].getService(Components.interfaces.nsIWebProgress);

      docLoaderSvc.addProgressListener(this, Components.interfaces.nsIWebProgress.NOTIFY_ALL);

    }
    else if (aTopic == "domwindowopened") {

        var loader = Components.classes['@mozilla.org/moz/jssubscript-loader;1'].getService(Components.interfaces.mozIJSSubScriptLoader);
        loader.loadSubScript('chrome://shakensurf/content/shakensurf.js');        
	}
  },

  contentLoaded: function(e) {
    Shakensurf.onInstall();
    },

  // nsIWebProgressListener
  onStateChange: function onStateChange(aWebProgress, aRequest, aStateFlags, aStatus)
  {
    var curWindow = aWebProgress.DOMWindow;
    
    if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST &&
        aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT) {
          listen(curWindow.document, "DOMContentLoaded", hitch(this, "contentLoaded"));
    }
  },

  onProgressChange: function onProgressChange(wp, r, csp, msp, ctp, mtp) {},
  onLocationChange: function onLocationChange(wp, r, l) {},
  onStatusChange: function onStatusChange(wp, r, s, m) {},
  onSecurityChange: function onSecurityChange(wp, r, s) {}
}

function hitch(obj, meth) {
  return function() { return obj[meth].apply(obj, arguments); }
}

function listen(source, event, listener, opt_capture) {
  Components.lookupMethod(source, "addEventListener")(
                          event, listener, opt_capture);
}

//=================================================
// Note: You probably don't want to edit anything
// below this unless you know what you're doing.
//
// Factory
var shakensurfFactory = {
  singleton: null,
  createInstance: function (aOuter, aIID)
  {
    if (aOuter != null)
      throw Components.results.NS_ERROR_NO_AGGREGATION;
    if (this.singleton == null)
      this.singleton = new shakensurf();
    return this.singleton.QueryInterface(aIID);
  }
};

// Module
var shakensurfModule = {
  registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
  {
    aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, aFileSpec, aLocation, aType);

    // Need to delete category before removing, nsIContentPolicies in Gecko 1.9 listens to
    // category changes
    var catman = Components.classes["@mozilla.org/categorymanager;1"]
                           .getService(Components.interfaces.nsICategoryManager);
    catman.addCategoryEntry("app-startup", CLASS_NAME,
                            CONTRACT_ID, true, true);
  },

  unregisterSelf: function(aCompMgr, aLocation, aType)
  {
    aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);

    var catman = Components.classes["@mozilla.org/categorymanager;1"]
                           .getService(Components.interfaces.nsICategoryManager);
    catman.deleteCategoryEntry("app-startup", CONTRACT_ID, true);
  },

  getClassObject: function(aCompMgr, aCID, aIID)
  {
    if (!aIID.equals(Components.interfaces.nsIFactory))
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    if (aCID.equals(CLASS_ID))
      return shakensurfFactory;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(aCompMgr) { return true; }
};

//module initialization
function NSGetModule(aCompMgr, aFileSpec) {
  return shakensurfModule;
}
